import { prisma } from "@/module/_global";
import { funGetUserById } from "@/module/auth";
import { createLogUserMobile } from "@/module/user";
import { NextResponse } from "next/server";

export const dynamic = 'force-dynamic'
export const revalidate = true

export async function GET(request: Request, context: { params: { id: string } }) {
   try {
      const { searchParams } = new URL(request.url);
      const userMobile = searchParams.get("user")

      if (userMobile == "null" || userMobile == undefined || userMobile == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const { id } = context.params;
      const data = await prisma.group.findUnique({
         where: {
            id: id,
         },
      });

      if (!data) {
         return NextResponse.json(
            {
               success: false,
               message: "Gagal mendapatkan grup, data tidak ditemukan",
            },
            { status: 200 }
         );
      }

      return NextResponse.json(
         {
            success: true,
            message: "Berhasil mendapatkan grup",
            data,
         },
         { status: 200 }
      );
   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mendapatkan grup, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}

export async function DELETE(request: Request, context: { params: { id: string } }) {
   try {
      const { id } = context.params;
      const { isActive, user } = (await request.json());

      if (user == "null" || user == undefined || user == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }
      const userLogin = await funGetUserById({ id: user })

      const data = await prisma.group.count({
         where: {
            id: id,
         },
      });

      if (data == 0) {
         return NextResponse.json(
            {
               success: false,
               message: "Edit grup gagal, data tidak ditemukan",
            },
            { status: 200 }
         );
      }

      const update = await prisma.group.update({
         where: {
            id: id,
         },
         data: {
            isActive: !isActive,
         },
      });

      // create log user
      const log = await createLogUserMobile({ act: 'UPDATE', desc: 'User mengedit status data grup', table: 'group', data: id, user })

      return NextResponse.json({ success: true, message: "Grup berhasil diedit", }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mengedit grup, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}

export async function PUT(request: Request, context: { params: { id: string } }) {
   try {
      const { id } = context.params;
      const { name, user } = (await request.json());

      if (user == "null" || user == undefined || user == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const data = await prisma.group.count({
         where: {
            id: id,
         },
      });

      if (data == 0) {
         return NextResponse.json(
            {
               success: false,
               message: "Edit grup gagal, data tidak ditemukan",
            },
            { status: 200 }
         );
      }

      const update = await prisma.group.update({
         where: {
            id: id,
         },
         data: {
            name: name,
         },
      });

      // create log user
      const log = await createLogUserMobile({ act: 'UPDATE', desc: 'User mengedit data grup', table: 'group', data: id, user })

      return NextResponse.json({ success: true, message: "Grup berhasil diedit" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mengedit grup, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}